"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.shouldRecover = void 0;
var state_1 = require("../state");
var initialValues_1 = require("./initialValues");
var shouldRecover = function (error) {
    var _a = (0, state_1.getState)(), options = _a.options, token = _a.cache.token, recoveryTries = _a.recoveryTries;
    var response = error.response;
    if (!response) {
        return false;
    }
    var status = response.status;
    var refreshOnStatus = options.refreshOnStatus, maxRecoveryTries = options.maxRecoveryTries, onAuthFail = options.onAuthFail, onRecoveryAbort = options.onRecoveryAbort, addTokenToLogs = options.addTokenToLogs;
    var authFailed = refreshOnStatus.includes(status);
    if (authFailed) {
        var access_token = token.access_token;
        var message = addTokenToLogs ? "Used token: ".concat(access_token) : '';
        onAuthFail(message);
        if (recoveryTries < maxRecoveryTries) {
            (0, state_1.updateState)({
                inRecovery: true,
                recoveryTries: recoveryTries + 1,
                cache: initialValues_1.initCache
            });
            return true;
        }
        else {
            (0, state_1.updateState)({
                inRecovery: false,
                recoveryTries: 0,
                cache: initialValues_1.initCache
            });
            onRecoveryAbort();
        }
    }
    return false;
};
exports.shouldRecover = shouldRecover;
